#!/usr/bin/env python


import wx
from nardascripting.base.signalsharkdev import *
from nardascripting.base.usrscriptbase import *
from nardascripting.base.measthread import *
from .mydialogsbase import MySettingsBaseDlg, MyMeasGUIBaseDlg
from . import scriptimages


class MySettingsDlg(MySettingsBaseDlg):
    """Settings dialog"""

    def __init__(self, parent):
        """Initialization"""
        super().__init__(parent)
        #self.lbl_my_label.SetLabelText(msg)


class MyMeasGUIDlg(MyMeasGUIBaseDlg):
    """Custom dialog class for data visualization."""

    def __init__(self, parent, title: str):
        """Dialog class for data visualization.

        :param parent: The parent window as wx.Window.
        """
        super().__init__(parent=parent)

        self.init_progress_bar(self.pgb_progress)
        self.init_dlg_buttons(self.sdbs_buttons, wx.OK)
        self.btn_ok.SetLabel('Quit')
        self.SetTitle(title)

        # Setup images
        self.bmp_symbol.SetBitmap(scriptimages.img_meas_symbol.GetBitmap())

        # self.Maximize(True)

    def update_progress(self, evt: ProgressEvent):
        """Receives data from thread and updates progressbar and message text

        :param evt: Event of type ProgressEvent.
        """

        # Handle progress
        self.update_progress_bar(evt, self.pgb_progress)

        # Handle message
        if evt.msg is not None:
            self.lbl_status.SetLabelText(evt.msg)

        # Handle data:
        if evt.data is not None:
            self.txt_my_meas_values.SetLabelText(str(evt.data))

        # Handle buttons:
        if evt.btn_style:
            self.update_btn_style(evt.btn_style)

        # Handle icons:
        if evt.icon_style:
            self.update_icon_style(self.bmp_icon, evt.icon_style)

        # Handle help text:
        if evt.help_text:
            self.help_text = evt.help_text

        self.Layout()
        self.Refresh()
        self.Update()

    # Code here --------------------------------------------------------------------------------------
    # Add more methods here if required
    # If virtual event handlers are used in MyMeasGUIBaseDlg, over-ride them here in the derived class
    # ------------------------------------------------------------------------------------------------


# This is just a python module containing helper classes/functions:
if __name__ == '__main__':
    pass
